
// ChevMsgrClient_MFCDlg.cpp :  
//

#include "stdafx.h"
#include "ChevMsgrClient_MFC.h"
#include "ChevMsgrClient_MFCDlg.h"
#include "afxdialogex.h"
#include <fstream>
#include <algorithm>

#include "LoginDlg.h"
#include "RegisterDlg.h"
#include "SMSDlg.h"
#include "AddFriendDlg.h"
#include "AddGroupChat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

int cb_listen(SConversation & chat);
int cb_opensession(SOpenSession & opensession);

CChevMsgrClient_MFCDlg * gDlg = NULL;

//  α׷  Ǵ CAboutDlg ȭ Դϴ.

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ȭ  Դϴ.
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

// Դϴ.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CChevMsgrClient_MFCDlg ȭ 



CChevMsgrClient_MFCDlg::CChevMsgrClient_MFCDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_CHEVMSGRCLIENT_MFC_DIALOG, pParent)
	, mCheckedSensitive(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	gDlg = this;
}

void CChevMsgrClient_MFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_CONVERSATION, mChatListBox);
	DDX_Control(pDX, IDC_LIST_FRIENDS, mFriendListBox);
	DDX_Check(pDX, IDC_CHECK_SENSITIVE, mCheckedSensitive);
}

BEGIN_MESSAGE_MAP(CChevMsgrClient_MFCDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_SEND, &CChevMsgrClient_MFCDlg::OnBnClickedBtnSend)
	ON_BN_CLICKED(IDC_BTN_ADD_FRIEND, &CChevMsgrClient_MFCDlg::OnBnClickedBtnAddFriend)
	ON_BN_CLICKED(IDC_BTN_ADD_CHAT, &CChevMsgrClient_MFCDlg::OnBnClickedBtnAddChat)
	ON_LBN_SELCHANGE(IDC_LIST_FRIENDS, &CChevMsgrClient_MFCDlg::OnLbnSelchangeListFriends)
END_MESSAGE_MAP()


// CChevMsgrClient_MFCDlg ޽ ó

BOOL CChevMsgrClient_MFCDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ý ޴ "..." ޴ ׸ ߰մϴ.

	// IDM_ABOUTBOX ý   ־ մϴ.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	//  ȭ   մϴ.   α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.

	std::ifstream f("cnct2srv.ini");
	if (!f)
	{
		AfxMessageBox(_T("   ã  "));
		::SendMessage(GetSafeHwnd(), WM_QUIT, NULL, NULL);
	}
	std::string ip;
	std::string port;

	std::getline(f, ip);
	std::getline(f, port);

	if (!chev.connect(ip, atoi(port.c_str())))
	{
		AfxMessageBox(str2cstr(chev.getLastError()));
		::SendMessage(GetSafeHwnd(), WM_QUIT, NULL, NULL);
	}

	CLoginDlg loginDlg;
	loginDlg.chev = &this->chev;
	if (loginDlg.DoModal() != 0)
	{
		AfxMessageBox(_T("login failed"));
		::SendMessage(GetSafeHwnd(), WM_QUIT, NULL, NULL);
	}

	this->mId = loginDlg.mId;

	SCallback cb;

	cb.onListen = cb_listen;
	cb.onOpenSession = cb_opensession;

	chev.listen(cb);

	UpdateFriendList();

	scl.resize(idList.size());

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

void CChevMsgrClient_MFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ.  /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CChevMsgrClient_MFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮԴϴ.

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CChevMsgrClient_MFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

int cb_listen(SConversation & chat)
{
	int idx = -1;

	for (idx = 0; idx < gDlg->mFriendListBox.GetCount(); idx++)
	{
		if (chat.sessid == gDlg->scl[idx].sessionId)
		{
			gDlg->scl[idx].chatList.push_back(chat);
			break;
		}
	}

	if (gDlg->mFriendListBox.GetCurSel() == idx)
	{
		gDlg->mChatListBox.InsertString(gDlg->mChatListBox.GetCount(), str2cstr("<" + chat.from + ">"));
		gDlg->mChatListBox.InsertString(gDlg->mChatListBox.GetCount(), str2cstr(chat.message));
		gDlg->mChatListBox.InsertString(gDlg->mChatListBox.GetCount(), _T(""));
	}

	return 0;
}

int cb_opensession(SOpenSession & opensession)
{
	if (opensession.idList.size() == 2)
		return 0;

	CString cstrIdList = _T("");

	for (size_t iter = 0; iter < opensession.idList.size(); iter++)
	{
		if (opensession.idList[iter] != gDlg->mId)
		{
			if (cstrIdList == "")
				cstrIdList = str2cstr(opensession.idList[iter]);
			else
				cstrIdList = cstrIdList + "," + str2cstr(opensession.idList[iter]);
		}
	}

	gDlg->mFriendListBox.InsertString(gDlg->mFriendListBox.GetCount(), cstrIdList);

	Session s;
	s.sessionId = opensession.sessid;

	gDlg->scl.push_back(s);

	return 0;
}

void CChevMsgrClient_MFCDlg::OnBnClickedBtnSend()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString chat;
	CString receiver;
	SConversation conversation;
	int idx = mFriendListBox.GetCurSel();

	if (idx < 0)
		return;

	mFriendListBox.GetText(idx, receiver);
	GetDlgItemText(IDC_EDIT_INPUT, chat);
	UpdateData(TRUE);

	if(scl[idx].sessionId == "")
	{
		std::vector<std::string> idList;
		std::string comma;
		mFriendListBox.GetText(idx, receiver);
		std::istringstream is(cstr2str(receiver));
		while (std::getline(is, comma, ','))
			idList.push_back(comma);
		std::sort(idList.begin(), idList.end());
		scl[idx].sessionId = chev.getSessionID(idList);
	}

	conversation.sessid = scl[idx].sessionId;
	conversation.from = this->mId;
	conversation.message = cstr2str(chat);
	conversation.sensitive = mCheckedSensitive ? true : false;

	if (chev.tell(conversation))
	{
		mChatListBox.InsertString(mChatListBox.GetCount(), str2cstr("<" + mId + ">"));
		mChatListBox.InsertString(mChatListBox.GetCount(), chat);
		mChatListBox.InsertString(mChatListBox.GetCount(), _T(""));
	}

	gDlg->scl[gDlg->mFriendListBox.GetCurSel()].chatList.push_back(conversation);
	
	SetDlgItemText(IDC_EDIT_INPUT, _T(""));
}

void CChevMsgrClient_MFCDlg::OnBnClickedBtnAddFriend()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CAddFriendDlg AFDlg;

	AFDlg.chev = &this->chev;
	AFDlg.mMsgrClntDlg = this;

	AFDlg.DoModal();
	UpdateFriendList();
}


void CChevMsgrClient_MFCDlg::OnBnClickedBtnAddChat()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CAddGroupChatDlg AGCDlg;

	AGCDlg.chev = &this->chev;
	AGCDlg.mMsgrClntDlg = this;
	AGCDlg.DoModal();

	CString cmpCstr;
	for (int iter = 0; iter < this->mFriendListBox.GetCount(); iter++)
	{
		this->mFriendListBox.GetText(iter, cmpCstr);
		if (AGCDlg.groupChat == cmpCstr)
			return;
	}

	mFriendListBox.InsertString(mFriendListBox.GetCount(), AGCDlg.groupChat);
	gDlg->scl.resize(gDlg->scl.size() + 1);
}

void CChevMsgrClient_MFCDlg::UpdateFriendList()
{
	CString cstrId;
	if (!chev.getFriendList(idList))
	{
		AfxMessageBox(_T("cannot get friend list"));
		::SendMessage(GetSafeHwnd(), WM_QUIT, NULL, NULL);
	}

	this->mFriendListBox.ResetContent();

	for (size_t iter = 0; iter < idList.size(); iter++)
	{
		cstrId = str2cstr(idList[iter].id);
		this->mFriendListBox.InsertString(this->mFriendListBox.GetCount(), cstrId);
	}
}

void CChevMsgrClient_MFCDlg::OnLbnSelchangeListFriends()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	mChatListBox.ResetContent();
	int idx = mFriendListBox.GetCurSel();
	
	if (idx < 0)
		return;
	
	// vector out of range error
	if (scl[idx].sessionId == "")
		return;

	for (std::list<SConversation>::iterator iter = scl[idx].chatList.begin();
	iter != scl[idx].chatList.end(); iter++)
	{
		mChatListBox.InsertString(mChatListBox.GetCount(), str2cstr("<" + iter->from + ">"));
		mChatListBox.InsertString(mChatListBox.GetCount(), str2cstr(iter->message));
		mChatListBox.InsertString(mChatListBox.GetCount(), _T(""));
	}
}
